package gov.nist.biometrics.bias {
	import mx.rpc.AsyncToken;
	import mx.rpc.Responder;
	
	import services.bias.BIAS;
	
	import valueObjects.EnrollRequest;
	import valueObjects.IdentifyRequest;
	import valueObjects.QueryCapabilitiesRequest;
	import valueObjects.RetrieveInformationRequest;
	import valueObjects.VerifyRequest;
	
	public class ServiceManager {
		import mx.rpc.events.FaultEvent;
		import mx.rpc.events.ResultEvent;
		import mx.rpc.soap.WebService;
		
		private static var instance:ServiceManager;
		private var ws:WebService;
		
		function ServiceManager() {
			ws = new WebService();
			ws.wsdl = Utilities.getInstance().ServiceHostname + ":" + Utilities.getInstance().ServicePort + "/" + Utilities.getInstance().ServiceContext + "?wsdl";
			//ws.wsdl = "http://localhost:12345/BIAS?wsdl";
			ws.loadWSDL();
		}
		
		public static function getInstance():ServiceManager {
			if (instance == null)
				instance = new ServiceManager();
			
			return instance;
		}
		
		public function clearAllEventHandlers():void {
			
			//ws.re
		}
		
		public function defaultFaultHandler(e:FaultEvent):void {
			trace(e.message);
		}

		public function queryCapabilities(resultHandler:Function, faultHandler:Function, request:QueryCapabilitiesRequest):void {
			if (faultHandler == null) {
				ws.addEventListener("fault", defaultFaultHandler);
			} else {
				ws.addEventListener("fault", faultHandler);
			}
			
			ws.QueryCapabilities.addEventListener("result", resultHandler);
			ws.QueryCapabilities(new QueryCapabilitiesRequest());
		}
		
		public function retrieveInformation(resultHandler:Function, faultHandler:Function, request:RetrieveInformationRequest):void {
			if (faultHandler == null) {
				ws.addEventListener("fault", defaultFaultHandler);
			} else {
				ws.addEventListener("fault", faultHandler);
			}
			
			ws.RetrieveInformation.addEventListener("result", resultHandler);
			ws.RetrieveInformation(request);
		}
		
		public function performEnrollment(resultHandler:Function, faultHandler:Function, request:EnrollRequest):void {
			if (faultHandler == null) {
				ws.addEventListener("fault", defaultFaultHandler);
			} else {
				ws.addEventListener("fault", faultHandler);
			}
			
			ws.Enroll.addEventListener("result", resultHandler);
			ws.Enroll(request);
		}
		
		public function performVerification(resultHandler:Function, faultHandler:Function, request:VerifyRequest):void {
			if (faultHandler == null) {
				ws.addEventListener("fault", defaultFaultHandler);
			} else {
				ws.addEventListener("fault", faultHandler);
			}
			
			ws.Verify.addEventListener("result", resultHandler);
			ws.Verify(request);
		}
		
		public function performIdentification(resultHandler:Function, faultHandler:Function, request:IdentifyRequest):void {
			if (faultHandler == null) {
				ws.addEventListener("fault", defaultFaultHandler);
			} else {
				ws.addEventListener("fault", faultHandler);
			}
			
			ws.Identify.addEventListener("result", resultHandler);
			ws.Identify(request);
		}
	}
}