﻿Option Strict On

Imports System.ServiceModel
Imports System.ServiceModel.Description
Imports System.ServiceModel.Web
Imports Nist.Logging
Imports System.Text
Imports System.IO

Module EntryPoint

    Sub Main()
        Gallery.Load()
        StartService()
    End Sub

    Sub StartService()
        Info("BaseURI: {0}", ServiceBaseAddress)

        Dim host As New ServiceHost(GetType(BIASService), New Uri(ServiceBaseAddress))

        Dim binding = New BasicHttpBinding()
        binding.Namespace = "http://docs.oasis-open.org/bias/ns/bias-1.0/"
        binding.MaxReceivedMessageSize = BindingMaxReceivedMessageSize
        binding.MaxBufferSize = BindingMaxBufferSize
        binding.ReaderQuotas.MaxArrayLength = Integer.MaxValue
        binding.ReaderQuotas.MaxStringContentLength = Integer.MaxValue


        Dim b As New WebHttpBehavior()
        b.FaultExceptionEnabled = True

        host.AddServiceEndpoint(GetType(BIAS_v1), binding, "bias")
        host.AddServiceEndpoint(GetType(IPolicyRetriever), New WebHttpBinding(), "").Behaviors.Add(b)


        Dim metadataBehavior As ServiceMetadataBehavior = If(host.Description.Behaviors.Find(Of ServiceMetadataBehavior)() Is Nothing, New ServiceMetadataBehavior(), host.Description.Behaviors.Find(Of ServiceMetadataBehavior)())
        metadataBehavior.HttpGetEnabled = True
        host.Description.Behaviors.Add(metadataBehavior)
        host.AddServiceEndpoint(ServiceMetadataBehavior.MexContractName, MetadataExchangeBindings.CreateMexHttpBinding(), "mex")









        For Each endpoint As ServiceEndpoint In host.Description.Endpoints()
            Console.WriteLine("Binding: {0}, address: {1}", endpoint.Binding.GetType().Name, endpoint.Address.Uri)
        Next



        ''Console.WriteLine("Binding: {0}, address: {1}", endpoint.Binding.GetType().Name, endpoint.Address.Uri);







        host.Open()
        Console.ReadLine()
        host.Close()

        'C:\Program Files (x86)\Microsoft Visual Studio 10.0\Common7\IDE\WcfTestClient.exe
        'svcutil http://localhost:12345/BIAS (uses WS-MetadataExchange or DISCO)
    End Sub

End Module

<ServiceContract()>
Public Interface IPolicyRetriever

    <OperationContract(), WebGet(UriTemplate:="/crossdomain.xml")>
    Function GetPolicy() As Stream

    '    Dim policy = "<?xml version='1.0'?><!DOCTYPE cross-domain-policy SYSTEM 'http://www.macromedia.com/xml/dtds/cross-domain-policy.dtd'> <cross-domain-policy><allow-access-from domain='*' /></cross-domain-policy>"
    '   WebOperationContext.Current.OutgoingResponse.ContentType = "application/xml"
    '  Return New MemoryStream(Encoding.UTF8.GetBytes(policy))
    'End Function

End Interface